unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,ProcessorUsage, StdCtrls, ExtCtrls, TeeProcs, TeEngine, Chart,
  Series;


const
  valuescount=100;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    MainGraphic: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  c:DWORD=0;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  p:pointer;
begin
  p:=GetNativeSystemInfo(SystemProcessorTimes);

  ShowMessage(IntToHex(DWORD(p),8));
end;

var
  PU:PROCESSORS_USAGES;

var
  Current:DWORD;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  c,i:WORD;
  CPUUsages:PROCESSORS_USAGES;
  CPUUSAGE:single;
begin
  c:=GetProcessorsCount;
  GetProcessorUsage(@CPUUsages);

  inc(current);

  for i:=0 to c-1 do
   begin
    if MainGraphic.Series[i].Count>valuescount then
     MainGraphic.Series[i].Delete(0);
    CPUUsage:=100-CPUUsages[i].IdleTime-CPUUsages[i].InterruptTime-CPUUsages[i].DpcTime;
    //CPUUsage:=100-CPUUsages[i].IdleTime;
    //if CPUUSAGE>100 then CPUUSAGE:=100;
    //if CPUUSAGE<0 then CPUUSAGE:=0;

    MainGraphic.Series[i].AddXY(current,CPUUSAGE,Format('%5.2f%%',[CPUUSAGE]));
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);

begin
  InitProcessors;
end;

end.
